KERNEL_PATH=$1

echo Generating simulator from $KERNEL_PATH

if [ ! -f $KERNEL_PATH/Makefile ]; then
	echo "$KERNEL_PATH doesn't look like the kernel source"
	exit 1
fi

#simple stuff first
cp $KERNEL_PATH/include/linux/clocksource.h ./linux/


#generate the ntp portions
TIMEFILE=./time.c

#first cut out a few full functions
echo '#include "sim.h"' > $TIMEFILE

sed --silent -e '/\/* XXX - all/,/0 for system./p' < $KERNEL_PATH/kernel/timer.c >> $TIMEFILE
echo "*/" >> $TIMEFILE

#apply simulator compile fixes
patch -p1 < simcomp.patch

#apply real fixes
patch -p1 < fixes.patch
