typedef unsigned long long u64;
typedef long long s64;
typedef unsigned long u32;

struct timespec {
	u32 tv_sec;
	long tv_nsec;
};
struct timeval {
	u32 tv_sec;
	long tv_usec;
};

#define EXPORT_SYMBOL_GPL(x)

#define CONFIG_GENERIC_TIME

#define NSEC_PER_SEC 1000000000
#define USEC_PER_SEC 1000000
#define NSEC_PER_USEC 1000

typedef u32 seqlock_t;

#define SEQLOCK_UNLOCKED 0
#define write_seqlock_irqsave(x,y)
#define write_sequnlock_irqrestore(x,y)
#define read_seqbegin(x) 0
#define read_seqretry(x,y) 0

#define __init

extern struct timespec xtime;
extern struct timespec wall_to_monotonic;


#define BUG_ON(x)
struct sys_device{
	int id;
	void* cls;
};
struct sysdev_class {
	void* resume;
	void* suspend;
	int i;
};
#define set_kset_name(x) 0
#define pm_message_t int
#define device_initcall(x) 
#define __iomem

struct list_head {
};

#define EXPORT_SYMBOL(x)

#define inline

#define do_div(n,base) ({ \
	unsigned long __upper, __low, __high, __mod, __base; \
	__base = (base); \
	asm("":"=a" (__low), "=d" (__high):"A" (n)); \
	__upper = __high; \
	if (__high) { \
		__upper = __high % (__base); \
		__high = __high / (__base); \
	} \
	asm("divl %2":"=a" (__low), "=d" (__mod):"rm" (__base), "0" (__low), "1" (__upper)); \
	asm("":"=A" (n):"a" (__low),"d" (__high)); \
	__mod; \
})

#define clock_was_set()
#define time_t u32

#define printk(x,...) {}

#ifndef div_long_long_rem
#define div_long_long_rem(dividend,divisor,remainder) 	\
({							\
	u64 result = dividend;				\
	*remainder = do_div(result,divisor);		\
	result;						\
})
#endif


#define EINVAL 1

static inline long div_long_long_rem_signed(long long dividend,
					    long divisor,
					    long *remainder)
{
	long res;

	if (unlikely(dividend < 0)) {
		res = -div_long_long_rem(-dividend, divisor, remainder);
		*remainder = -(*remainder);
	} else {
		res = div_long_long_rem(dividend, divisor, remainder);
	}
	return res;
}

static inline void timespec_add_ns(struct timespec *a, u64 ns)
{
	u64 tmp = (u64)a->tv_sec * NSEC_PER_SEC + a->tv_nsec + ns;
	a->tv_sec = tmp/NSEC_PER_SEC;
	a->tv_nsec = tmp%NSEC_PER_SEC;
}

#define time_interpolator_update(x) 
#define update_ntp_one_tick()
#define ntp_clear()
#define second_overflow()

extern struct clocksource *clocksource_get_next(void);
extern void do_gettimeofday(struct timeval *tv);
extern int do_settimeofday(struct timespec *tv);
extern u64 get_monotonic_clock(void);
extern void __init timekeeping_init(void);
extern void update_wall_time(void);
extern u64 current_tick_length(long shift);
#define tick_nsec 1000000
